// simple 1 screen demo(again. he he)

#include <gb.h>

#include "t_demo1.h" // tile 
#include "c_demo1.h" // color map 
#include "m_demo1.h" // map

#include "t_demo1.c" // tile
#include "c_demo1.c" // color map
#include "m_demo1.c" // map

UWORD bg_pal[] = {
  t_demo1_labelCGBPal0c0, t_demo1_labelCGBPal0c1, t_demo1_labelCGBPal0c2, t_demo1_labelCGBPal0c3,
  t_demo1_labelCGBPal1c0, t_demo1_labelCGBPal1c1, t_demo1_labelCGBPal1c2, t_demo1_labelCGBPal1c3,
  t_demo1_labelCGBPal2c0, t_demo1_labelCGBPal2c1, t_demo1_labelCGBPal2c2, t_demo1_labelCGBPal2c3,
  t_demo1_labelCGBPal3c0, t_demo1_labelCGBPal3c1, t_demo1_labelCGBPal3c2, t_demo1_labelCGBPal3c3,
  t_demo1_labelCGBPal4c0, t_demo1_labelCGBPal4c1, t_demo1_labelCGBPal4c2, t_demo1_labelCGBPal4c3,
  t_demo1_labelCGBPal5c0, t_demo1_labelCGBPal5c1, t_demo1_labelCGBPal5c2, t_demo1_labelCGBPal5c3,
  t_demo1_labelCGBPal6c0, t_demo1_labelCGBPal6c1, t_demo1_labelCGBPal6c2, t_demo1_labelCGBPal6c3,
  t_demo1_labelCGBPal7c0, t_demo1_labelCGBPal7c1, t_demo1_labelCGBPal7c2, t_demo1_labelCGBPal7c3
};

// prototype
void set_BG_pal();

// main
void main() {
  if(_cpu != 0x11) {  // if not GBC, halt!!
    while (!0) {}
  } else { // color GB init
    set_bkg_data(0, 127, t_demo1_label); // load tile

    VBK_REG = 1; // select tile bank 1 for color map
    set_bkg_tiles(0, 0, 20, 18, c_demo1_label); // load color map

    VBK_REG = 0; // select tile bank 0 for map
    set_bkg_tiles(0, 0, 20, 18, m_demo1_label); // load map

    set_BG_pal(); // load palette

    SHOW_BKG;
    DISPLAY_ON;
  }
}

void set_BG_pal() {
  set_bkg_palette( 0, 1, &bg_pal[ 0]);
  set_bkg_palette( 1, 1, &bg_pal[ 4]);
  set_bkg_palette( 2, 1, &bg_pal[ 8]);
  set_bkg_palette( 3, 1, &bg_pal[12]);
  set_bkg_palette( 4, 1, &bg_pal[16]);
  set_bkg_palette( 5, 1, &bg_pal[20]);
  set_bkg_palette( 6, 1, &bg_pal[24]);
  set_bkg_palette( 7, 1, &bg_pal[28]);
}
